Polygonnetz Formelement

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page Mesh Feature and the translation is 39% complete.
Outdated translations are marked like this.
Other languages:
Deutsch • ‎English • ‎français • ‎italiano • ‎polski

Einleitung

Ein Mesh Tree.svg Polygonnetz Formelement Objekt oder formal ein Mesh::Feature ist ein einfaches Element mit einem ihm zugeordneten Polygonnetz Objekt, das in der 3D Ansicht angezeigt werden kann.

Ein Polygonnetz Formelement ähnelt konzeptionell einem Part Formelement; Ersteres ist das Basisobjekt für Elemente mit "Polygonnetz" Information, während Letzteres das Basisobjekt für Elemente mit "geometrischer Form" Information ist.

Bitte beachte, dass der Workbench FEM.svg FEM Arbeitsbereich ebenfalls Polygonnetze verwendet, aber in diesem Fall wird ein anderes Objekt verwendet, das Fem FemPolygonnetzObjekt (Fem::FemMeshObject Klasse) genannt wird. Dieses Objekt ist nicht von Polygonnetz Formelement abgeleitet und hat daher andere Eigenschaften.

FreeCAD core objects.svg

Vereinfachtes Diagramm der Beziehungen zwischen den Kernobjekten im Programm. Die Mesh::Feature Klasse ist der Ursprung der meisten Objekte, die über ein Dreieckspolygonnetz verfügen. Diese Objekte werden von der Polygonnetz Arbeitsbereich oder durch Importieren von STL, OBJ und ähnlichen Polygonnetzformatdateien erstellt.

Anwendung

Fast alle Polygonnetz Objekte, die mit den in der grafischen Oberfläche Polygonnetz Arbeitsbereich verfügbaren Befehlen erzeugt werden, sind Polygonnetz Funktionen. Die einzige Ausnahme bilden die parametrischen Polygonnetzobjekte, die mit dem Befehl Polygonnetz BauRegularSolid erzeugt werden. Ein Polygonnetz Funktion kann auch über die Python Konsole erzeugt werden, wie im Abschnitt Skripten beschrieben.

The Mesh::Feature is defined in the Mesh Workbench but can be used as the base class for scripted objects in all workbenches that produce 2D and 3D meshes.

A Mesh::Feature has simple properties like a placement, and visual properties to define the appearance of its edges and faces.

Eigenschaften

A Mesh Feature (Mesh::Feature class) is derived from the basic App GeoFeature (App::GeoFeature class), therefore it shares all the latter's properties.

In addition to the properties described in App GeoFeature, the Mesh Feature has the DatenMesh property, which stores the Mesh MeshObject of this element; this is the geometry that is shown in the 3D view.

Other properties that this object has are those related to the appearance of its Mesh MeshObject, including AnsichtCrease Angle, AnsichtLighting, AnsichtLine Color, AnsichtLine Transparency, AnsichtLine Width, AnsichtOpen Edges, AnsichtPoint Size, and also the hidden property AnsichtColoring.

See Property for all property types that scripted objects can have.

These are the properties available in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Daten

Base

  • DatenMesh (MeshKernel): a Mesh MeshObject class associated with this object. It lists the number of Points, Edges, and Faces of the mesh.
  • DatenPlacement (Placement): the position of the object in the 3D view. The placement is defined by a Base point (vector), and a Rotation (axis and angle). See Placement.
    • DatenAngle: the angle of rotation around the DatenAxis. By default, it is (zero degrees).
    • DatenAxis: the unit vector that defines the axis of rotation for the placement. Each component is a floating point value between 0 and 1. If any value is above 1, the vector is normalized so that the magnitude of the vector is 1. By default, it is the positive Z axis, (0, 0, 1).
    • DatenPosition: a vector with the 3D coordinates of the base point. By default, it is the origin (0, 0, 0).
  • DatenLabel (String): the user editable name of this object, it is an arbitrary UTF8 string.

Ausgeblendete Dateneigenschaften

Base

  • DatenExpression Engine (ExpressionEngine): a list of expressions. By default, it is empty [].
  • DatenLabel2 (String): a longer, user editable description of this object, it is an arbitrary UTF8 string that may include newlines. By default, it is an empty string "".
  • DatenProxy (PythonObject): a custom class associated with this object. This only exists for the Python version. See Scripting.
  • DatenVisibility (Bool): whether to display the object or not.

Ansicht

Most objects in FreeCAD have what is called a "view provider", which is a class that defines the visual appearance of the object in the 3D view, and in the tree view. The default view provider of Mesh Feature objects defines the following properties. Scripted objects that are derived from Mesh Feature will have access to these properties as well.

Base

  • AnsichtBounding Box (Bool): if it is true, the object will show the bounding box in the 3D view.
  • AnsichtCrease Angle (FloatConstraint):
  • AnsichtDisplay Mode (Enumeration): Shaded (no edges), Wireframe (no faces), Flat Lines (regular visualization), Points (only vertices).
  • AnsichtLighting (Enumeration): One side (default), Two side; the illumination comes from two sides or one side in the 3D view.
  • AnsichtLine Color (Color): a tuple of three floating point RGB values (r,g,b) to define the color of the edges in the 3D view; by default it is (0.0, 0.0, 0.0), which is displayed as [0,0,0] on base 255, completely black .
  • AnsichtLine Transparency (Percent): an integer from 0 to 100 (a percentage) that determines the level of transparency of the edges in the 3D view. A value of 100 indicates completely invisible edges; the edges are invisible but they can still be picked as long as AnsichtSelectable is true.
  • AnsichtLine Width (FloatConstraint): a float that determines the width in pixels of the edges in the 3D view. It defaults to 1.0.
  • AnsichtOn Top When Selected (Enumeration): Disabled (default), Enabled, Object, Element.
  • AnsichtOpen Edges (Bool): it defaults to false.
  • AnsichtPoint Size (FloatConstraint): similar to AnsichtLine Width, defines the size of the vertices.
  • AnsichtSelectable (Bool): if it is true, the object can be picked with the pointer in the 3D view. Otherwise, the object cannot be selected until this option is set to true.
  • AnsichtSelection Style (Enumeration): Shape (default), BoundBox. If the option is Shape, the entire shape (vertices, edges, and faces) will be highlighted in the 3D view; if it is BoundBox only the bounding box will be highlighted.
  • AnsichtShape Color (Color): similar to AnsichtLine Color, defines the color of the faces. It defaults to (0.8, 0.8, 0.8), which is displayed as [204,204,204] on base 255, a light gray.
  • AnsichtShow In Tree (Bool): if it is true, the object appears in the tree view. Otherwise, it is set as invisible.
  • AnsichtTransparency (Percent): an integer from 0 to 100 (a percentage) that determines the level of transparency of the faces in the 3D view. A value of 100 indicates completely invisible faces; the faces are invisible but they can still be picked as long as AnsichtSelectable is true.
  • AnsichtVisibility (Bool): if it is true, the object appears in the 3D view; otherwise it is invisible. By default this property can be toggled on and off by pressing the Space bar in the keyboard.

Ausgeblendete Eigenschaften Ansicht

Base

  • AnsichtColoring (Bool): it defaults to false.
  • AnsichtProxy (PythonObject): a custom view provider class associated with this object. This only exists for the Python version. See Scripting.
  • AnsichtShape Material (Material): an App Material associated with this object. By default it is empty.

Skripten

See also: FreeCAD Scripting Basics, and scripted objects.

See Part Feature for the general information on adding objects to the program.

A Mesh Feature is created with the addObject() method of the document.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Mesh::Feature", "Name")
obj.Label = "Custom label"

This basic Mesh::Feature doesn't have a Proxy object so it can't be fully used for sub-classing.

Therefore, for Python subclassing, you should create the Mesh::FeaturePython object.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Mesh::FeaturePython", "Name")
obj.Label = "Custom label"